summaryrefslogtreecommitdiffstats
path: root/source/d
diff options
context:
space:
mode:
author Patrick J Volkerding <volkerdi@slackware.com>2022-12-07 18:48:07 +0000
committer Eric Hameleers <alien@slackware.com>2022-12-07 22:19:17 +0100
commitb98f1614c2434795d7875acd773a28f67a57bd72 (patch)
treecc1663ed32356c3982f64e8ddd3718b313e8608a /source/d
parentdf3f13247e63251d736003bd05cd91cc110ad6cf (diff)
downloadcurrent-b98f1614c2434795d7875acd773a28f67a57bd72.tar.gz
current-b98f1614c2434795d7875acd773a28f67a57bd72.tar.xz
Wed Dec 7 18:48:07 UTC 202220221207184807
d/cargo-vendor-filterer-0.5.7-x86_64-1.txz: Added. Thanks to Heinz Wiesinger. d/cbindgen-0.24.3-x86_64-1.txz: Added. d/python3-3.9.16-x86_64-1.txz: Upgraded. This update fixes security issues: gh-98739: Updated bundled libexpat to 2.5.0 to fix CVE-2022-43680 (heap use-after-free). gh-98433: The IDNA codec decoder used on DNS hostnames by socket or asyncio related name resolution functions no longer involves a quadratic algorithm to fix CVE-2022-45061. This prevents a potential CPU denial of service if an out-of-spec excessive length hostname involving bidirectional characters were decoded. Some protocols such as urllib http 3xx redirects potentially allow for an attacker to supply such a name. gh-100001: python -m http.server no longer allows terminal control characters sent within a garbage request to be printed to the stderr server log. gh-87604: Avoid publishing list of active per-interpreter audit hooks via the gc module. gh-97514: On Linux the multiprocessing module returns to using filesystem backed unix domain sockets for communication with the forkserver process instead of the Linux abstract socket namespace. Only code that chooses to use the "forkserver" start method is affected. This prevents Linux CVE-2022-42919 (potential privilege escalation) as abstract sockets have no permissions and could allow any user on the system in the same network namespace (often the whole system) to inject code into the multiprocessing forkserver process. Filesystem based socket permissions restrict this to the forkserver process user as was the default in Python 3.8 and earlier. gh-98517: Port XKCP's fix for the buffer overflows in SHA-3 to fix CVE-2022-37454. gh-68966: The deprecated mailcap module now refuses to inject unsafe text (filenames, MIME types, parameters) into shell commands to address CVE-2015-20107. Instead of using such text, it will warn and act as if a match was not found (or for test commands, as if the test failed). For more information, see: https://pythoninsider.blogspot.com/2022/12/python-3111-3109-3916-3816-3716-and.html https://www.cve.org/CVERecord?id=CVE-2022-43680 https://www.cve.org/CVERecord?id=CVE-2022-45061 https://www.cve.org/CVERecord?id=CVE-2022-42919 https://www.cve.org/CVERecord?id=CVE-2022-37454 https://www.cve.org/CVERecord?id=CVE-2015-20107 (* Security fix *) d/rust-bindgen-0.63.0-x86_64-1.txz: Added. Thanks to Heinz Wiesinger. l/pcre2-10.41-x86_64-1.txz: Upgraded. n/proftpd-1.3.8-x86_64-1.txz: Upgraded. x/mesa-22.3.0-x86_64-1.txz: Upgraded. Compiled with Rusticl support. Thanks to Heinz Wiesinger. x/xdm-1.1.14-x86_64-1.txz: Upgraded.
Diffstat (limited to 'source/d')
-rwxr-xr-xsource/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild125
-rwxr-xr-xsource/d/cargo-vendor-filterer/fetch-sources.sh45
-rw-r--r--source/d/cargo-vendor-filterer/slack-desc19
-rwxr-xr-xsource/d/cbindgen/cbindgen.SlackBuild125
-rwxr-xr-xsource/d/cbindgen/fetch-sources.sh34
-rw-r--r--source/d/cbindgen/slack-desc19
-rwxr-xr-xsource/d/rust-bindgen/fetch-sources.sh35
-rwxr-xr-xsource/d/rust-bindgen/rust-bindgen.SlackBuild126
-rw-r--r--source/d/rust-bindgen/slack-desc19
9 files changed, 547 insertions, 0 deletions
diff --git a/source/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild b/source/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild
new file mode 100755
index 000000000..74eaedbbb
--- /dev/null
+++ b/source/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild
@@ -0,0 +1,125 @@
+#!/bin/bash
+
+# Copyright 2022 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2022 Heinz Wiesinger, Amsterdam, The Netherlands
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PKGNAM=cargo-vendor-filterer
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-1}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i686 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
+NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PKGNAM
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+cd $TMP
+rm -rf $PKGNAM-$VERSION
+tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
+cd $PKGNAM-$VERSION || exit 1
+tar xvf $CWD/cargo-$PKGNAM-$VERSION.tar.?z || exit 1
+mv cargo-$PKGNAM-$VERSION vendor
+
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \+
+
+# Configure cargo for offline builds
+mkdir -p .cargo
+cat << EOF >> .cargo/config.toml
+[source.crates-io]
+replace-with = "vendored-sources"
+
+[source.vendored-sources]
+directory = "vendor"
+EOF
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+OPENSSL_NO_VENDOR=1 \
+cargo build \
+ --offline \
+ --release \
+ --target $ARCH-unknown-linux-gnu \
+ $NUMJOBS
+
+mkdir -p $PKG/usr/bin
+install -m 755 target/$ARCH-unknown-linux-gnu/release/cargo-vendor-filterer \
+ $PKG/usr/bin/
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PKGNAM-$VERSION
+cp -a *.md LICENSE \
+ $PKG/usr/doc/$PKGNAM-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/$PKGNAM-$VERSION-$ARCH-$BUILD.txz
diff --git a/source/d/cargo-vendor-filterer/fetch-sources.sh b/source/d/cargo-vendor-filterer/fetch-sources.sh
new file mode 100755
index 000000000..bab3da7c4
--- /dev/null
+++ b/source/d/cargo-vendor-filterer/fetch-sources.sh
@@ -0,0 +1,45 @@
+#!/bin/bash
+
+VERSION=${VERSION:-0.5.7}
+
+rm -rf cargo-vendor-filterer-*.tar.?z cargo-cargo-vendor-filterer*
+
+echo "Downloading cargo-vendor-filterer-$VERSION..."
+
+wget --content-disposition "https://github.com/coreos/cargo-vendor-filterer/archive/refs/tags/v$VERSION.tar.gz"
+
+tar xf cargo-vendor-filterer-$VERSION.tar.gz
+
+tar cf cargo-vendor-filterer-$VERSION.tar cargo-vendor-filterer-$VERSION
+
+cd cargo-vendor-filterer-$VERSION
+
+ # Configure cargo-vendor-filterer
+ cat << EOF >> Cargo.toml
+[package.metadata.vendor-filter]
+platforms = ["x86_64-unknown-linux-gnu", "i686-unknown-linux-gnu"]
+all-features = true
+exclude-crate-paths = [
+ { name = "openssl-src", exclude = "openssl" },
+]
+EOF
+
+
+ if ! [ -f /usr/bin/cargo-vendor-filterer ]; then
+ echo "WARNING: Creating unfiltered vendor libs tarball!"
+ cargo vendor
+ else
+ cargo vendor-filterer
+ fi
+
+ mv vendor ../cargo-cargo-vendor-filterer-$VERSION
+cd ..
+
+tar cf cargo-cargo-vendor-filterer-$VERSION.tar cargo-cargo-vendor-filterer-$VERSION
+
+plzip -9 cargo-cargo-vendor-filterer-$VERSION.tar
+plzip -9 cargo-vendor-filterer-$VERSION.tar
+
+rm -rf cargo-vendor-filterer-$VERSION
+rm -rf cargo-cargo-vendor-filterer-$VERSION
+rm -f cargo-vendor-filterer-$VERSION.tar.gz
diff --git a/source/d/cargo-vendor-filterer/slack-desc b/source/d/cargo-vendor-filterer/slack-desc
new file mode 100644
index 000000000..1c8d67c1e
--- /dev/null
+++ b/source/d/cargo-vendor-filterer/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+cargo-vendor-filterer: cargo-vendor-filterer (Vendor rust libraries based on filters)
+cargo-vendor-filterer:
+cargo-vendor-filterer: cargo-vendor-filterer works like "cargo vendor", but supports filters
+cargo-vendor-filterer: that allow excluding libraries one isn't interested in, like
+cargo-vendor-filterer: libraries only needed on other platforms, etc.
+cargo-vendor-filterer:
+cargo-vendor-filterer: Homepage: https://github.com/coreos/cargo-vendor-filterer
+cargo-vendor-filterer:
+cargo-vendor-filterer:
+cargo-vendor-filterer:
+cargo-vendor-filterer:
diff --git a/source/d/cbindgen/cbindgen.SlackBuild b/source/d/cbindgen/cbindgen.SlackBuild
new file mode 100755
index 000000000..eafbb61a0
--- /dev/null
+++ b/source/d/cbindgen/cbindgen.SlackBuild
@@ -0,0 +1,125 @@
+#!/bin/bash
+
+# Copyright 2022 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2022 Heinz Wiesinger, Amsterdam, The Netherlands
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PKGNAM=cbindgen
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-1}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i686 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
+NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PKGNAM
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+cd $TMP
+rm -rf $PKGNAM-$VERSION
+tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
+cd $PKGNAM-$VERSION || exit 1
+tar xvf $CWD/cargo-$PKGNAM-$VERSION.tar.?z || exit 1
+mv cargo-$PKGNAM-$VERSION vendor
+
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \+
+
+# Configure cargo for offline builds
+mkdir -p .cargo
+cat << EOF >> .cargo/config.toml
+[source.crates-io]
+replace-with = "vendored-sources"
+
+[source.vendored-sources]
+directory = "vendor"
+EOF
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+RUSTONIG_DYNAMIC_LIBONIG=1 \
+cargo build \
+ --offline \
+ --release \
+ --target $ARCH-unknown-linux-gnu \
+ --verbose \
+ $NUMJOBS || exit 1
+
+mkdir -p $PKG/usr/bin
+install -m 755 target/$ARCH-unknown-linux-gnu/release/cbindgen $PKG/usr/bin
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PKGNAM-$VERSION
+cp -a CHANGES *.md LICENSE* \
+ $PKG/usr/doc/$PKGNAM-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/$PKGNAM-$VERSION-$ARCH-$BUILD.txz
diff --git a/source/d/cbindgen/fetch-sources.sh b/source/d/cbindgen/fetch-sources.sh
new file mode 100755
index 000000000..17822dd6a
--- /dev/null
+++ b/source/d/cbindgen/fetch-sources.sh
@@ -0,0 +1,34 @@
+#!/bin/bash
+
+VERSION=${VERSION:-0.24.3}
+
+rm -rf cbindgen-*.tar.?z cargo-cbindgen*
+
+echo "Downloading cbindgen-$VERSION..."
+
+wget --content-disposition "https://github.com/eqrion/cbindgen/archive/refs/tags/v$VERSION.tar.gz"
+
+tar xf cbindgen-$VERSION.tar.gz
+
+tar cf cbindgen-$VERSION.tar cbindgen-$VERSION
+
+cd cbindgen-$VERSION
+
+ if ! [ -f /usr/bin/cargo-vendor-filterer ]; then
+ echo "WARNING: Creating unfiltered vendor libs tarball!"
+ cargo vendor
+ else
+ cargo vendor-filterer --platform="x86_64-unknown-linux-gnu" --platform="i686-unknown-linux-gnu"
+ fi
+
+ mv vendor ../cargo-cbindgen-$VERSION
+cd ..
+
+tar cf cargo-cbindgen-$VERSION.tar cargo-cbindgen-$VERSION
+
+plzip -9 cargo-cbindgen-$VERSION.tar
+plzip -9 cbindgen-$VERSION.tar
+
+rm -rf cbindgen-$VERSION
+rm -rf cargo-cbindgen-$VERSION
+rm -f cbindgen-$VERSION.tar.gz
diff --git a/source/d/cbindgen/slack-desc b/source/d/cbindgen/slack-desc
new file mode 100644
index 000000000..059507fca
--- /dev/null
+++ b/source/d/cbindgen/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+cbindgen: cbindgen (Generate C/C++ headers for Rust libraries)
+cbindgen:
+cbindgen: cbindgen creates C/C++11 headers for Rust libraries which expose a
+cbindgen: public C API. While you could do this by hand, it's not a particularly
+cbindgen: good use of your time. It's also much more likely to be error-prone
+cbindgen: than machine-generated headers that are based on your actual Rust
+cbindgen: code. The cbindgen developers have also worked closely with the
+cbindgen: developers of Rust to ensure that the headers we generate reflect
+cbindgen: actual guarantees about Rust's type layout and ABI.
+cbindgen:
+cbindgen: Homepage: https://github.com/eqrion/cbindgen
diff --git a/source/d/rust-bindgen/fetch-sources.sh b/source/d/rust-bindgen/fetch-sources.sh
new file mode 100755
index 000000000..3a2ad0074
--- /dev/null
+++ b/source/d/rust-bindgen/fetch-sources.sh
@@ -0,0 +1,35 @@
+#!/bin/bash
+
+#VERSION=$1
+VERSION=0.63.0
+
+rm -rf rust-bindgen-*.tar.?z cargo-rust-bindgen*
+
+echo "Downloading rust-bindgen-$VERSION..."
+
+wget --content-disposition "https://github.com/rust-lang/rust-bindgen/archive/refs/tags/v$VERSION.tar.gz"
+
+tar xf rust-bindgen-$VERSION.tar.gz
+
+tar cf rust-bindgen-$VERSION.tar rust-bindgen-$VERSION
+
+cd rust-bindgen-$VERSION
+
+ if ! [ -f /usr/bin/cargo-vendor-filterer ]; then
+ echo "WARNING: Creating unfiltered vendor libs tarball!"
+ cargo vendor
+ else
+ cargo vendor-filterer --platform="x86_64-unknown-linux-gnu" --platform="i686-unknown-linux-gnu"
+ fi
+
+ mv vendor ../cargo-rust-bindgen-$VERSION
+cd ..
+
+tar cf cargo-rust-bindgen-$VERSION.tar cargo-rust-bindgen-$VERSION
+
+plzip -9 cargo-rust-bindgen-$VERSION.tar
+plzip -9 rust-bindgen-$VERSION.tar
+
+rm -rf rust-bindgen-$VERSION
+rm -rf cargo-rust-bindgen-$VERSION
+rm -f rust-bindgen-$VERSION.tar.gz
diff --git a/source/d/rust-bindgen/rust-bindgen.SlackBuild b/source/d/rust-bindgen/rust-bindgen.SlackBuild
new file mode 100755
index 000000000..cc39557f1
--- /dev/null
+++ b/source/d/rust-bindgen/rust-bindgen.SlackBuild
@@ -0,0 +1,126 @@
+#!/bin/bash
+
+# Copyright 2022 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2022 Heinz Wiesinger, Amsterdam, The Netherlands
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PKGNAM=rust-bindgen
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-1}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i686 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
+NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PKGNAM
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+cd $TMP
+rm -rf $PKGNAM-$VERSION
+tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
+cd $PKGNAM-$VERSION || exit 1
+tar xvf $CWD/cargo-$PKGNAM-$VERSION.tar.?z || exit 1
+mv cargo-$PKGNAM-$VERSION vendor
+
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \+
+
+# Configure cargo for offline builds
+mkdir -p .cargo
+cat << EOF >> .cargo/config.toml
+[source.crates-io]
+replace-with = "vendored-sources"
+
+[source.vendored-sources]
+directory = "vendor"
+EOF
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+RUSTONIG_DYNAMIC_LIBONIG=1 \
+cargo build \
+ --offline \
+ --release \
+ --target $ARCH-unknown-linux-gnu \
+ --verbose \
+ $NUMJOBS || exit 1
+
+mkdir -p $PKG/usr/bin
+install -m 755 target/$ARCH-unknown-linux-gnu/release/bindgen \
+ $PKG/usr/bin/
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PKGNAM-$VERSION
+cp -a *.md LICENSE* \
+ $PKG/usr/doc/$PKGNAM-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/$PKGNAM-$VERSION-$ARCH-$BUILD.txz
diff --git a/source/d/rust-bindgen/slack-desc b/source/d/rust-bindgen/slack-desc
new file mode 100644
index 000000000..c8a4bfa68
--- /dev/null
+++ b/source/d/rust-bindgen/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+rust-bindgen: rust-bindgen (Generate Rust FFI bindings to C and C++ libraries)
+rust-bindgen:
+rust-bindgen: bindgen automatically generates Rust FFI bindings to C (and some C++)
+rust-bindgen: libraries.
+rust-bindgen:
+rust-bindgen: Homepage: https://github.com/rust-lang/rust-bindgen
+rust-bindgen:
+rust-bindgen:
+rust-bindgen:
+rust-bindgen:
+rust-bindgen: